#pragma once
#include "benchmark.h"

class CPUBenchmark : public Benchmark {
private:
  FLOAT   *fore_buffer_;
  FLOAT   *back_buffer_;

  inline
  void diffusion3d(FLOAT *f, FLOAT *fn, int nx, int ny, int nz,
                   FLOAT dx, FLOAT dy, FLOAT dz, FLOAT dt, FLOAT kappa);

public:
  CPUBenchmark() : fore_buffer_(NULL), back_buffer_(NULL) {
  }

  ~CPUBenchmark() {
    delete[] fore_buffer_;
    delete[] back_buffer_;
  }

  virtual void initialize(const int nx, const int ny, const int nz);
  virtual void run();
};
