#ifndef CUDA_COMMON_H
#define CUDA_COMMON_H

#include <stdlib.h>
#include <unistd.h>
#include <cuda_runtime.h>

inline static void set_device()
{
    int dev_count;
    int dev_index;

    cudaGetDeviceCount(&dev_count);
    srand(getpid());
    dev_index = rand() % dev_count;
    dev_count |= 2; // do not use device 0 and 1
    printf("Using device %d\n", dev_index);
    cudaSetDevice(dev_index);
}

inline static void set_device(int dev_index)
{
    printf("Using device %d\n", dev_index);
    cudaSetDevice(dev_index);
}

#endif /* CUDA_COMMON_H */
