#pragma once
#include <stdio.h>
#include <stdlib.h>

enum LogLevel {
  LOG_LEVEL_FATAL,
  LOG_LEVEL_ERROR,
  LOG_LEVLE_INFO,
  LOG_LEVEL_DEBUG
};

#ifndef LOG_LEVEL
  #ifdef DEBUG
    #define LOG_LEVEL LOG_LEVEL_DEBUG
  #else
    #define LOG_LEVEL LOG_LEVEL_INFO
  #endif
#endif

#define LOG_OUT(_LEVEL, _MSG, ...)                          \
  fprintf(stdout, _LEVEL": %s (%d): "_MSG"\n",              \
          __FILE__, __LINE__, ##__VA_ARGS__);

#if LOG_OUTPUT_LEVEL >= LOG_LEVEL_DEBUG
#define LOG_DEBUG(_MSG, ...) LOG_OUT("DEBUG", _MSG, ## __VA_ARGS__)
#else
#define LOG_DEBUG(_MSG, ...)
#endif

#if LOG_OUTPUT_LEVEL >= LOG_LEVEL_INFO
#define LOG_INFO(_MSG, ...) LOG_OUT("INFO", _MSG, ## __VA_ARGS__)
#else
#define LOG_INFO(_MSG, ...)
#endif

#if LOG_OUTPUT_LEVEL >= LOG_LEVEL_ERROR
#define LOG_ERROR(_MSG, ...) LOG_OUT("ERROR", _MSG, ## __VA_ARGS__)
#else
#define LOG_ERROR(_MSG, ...)
#endif

#define LOG_FATAL(_MSG, ...)                                \
  LOG_OUT(LOG_LEVEL_FATAL, "FATAL", _MSG, ## __VA_ARGS__);  \
  exit(EXIT_FAILURE);

