#include "omp_benchmark.h"
#include <omp.h>
#include "log.h"

#define NUM_GPU_DEVICES 2

void omp_gpu_run_diffusion3d(int tid, int nthreads,
                             Problem &prob,
                             FLOAT &final_time, 
                             int &final_iter_count);

void OMPGPUBenchmark::run() {
    FLOAT final_time;
    int final_iter_count;

    omp_set_num_threads(NUM_GPU_DEVICES);

    startTimer();    
#pragma omp parallel
    {
        int tid = omp_get_thread_num();
        int  nthreads  = omp_get_num_threads();
        omp_gpu_run_diffusion3d(tid, nthreads, problem_,
                                final_time, final_iter_count);
    }
    stopTimer();
    LOG_INFO("calculation has been done.");
    result_time_     = final_time;    
    result_accuracy_ = problem_.accuracy(problem_.f(), final_time);
    result_flops_    = (problem_.n.x * problem_.n.y * problem_.n.z) * 13.0 *
            final_iter_count/elapsed_time_*1.0e-06;

}

