#pragma once
#include "types.h"
#include <string>

struct Problem {
private:
  FLOAT *f_;
  FLOAT  time_;
  inline
  int index(const int x, const int y, const int z) const {
    return z*n.x*n.y + y*n.x + x;
  }

public:
  Size3d   n;       // problem size.
  Point3df l, d, k;
  FLOAT    kappa, dt;

  inline FLOAT *f() const { return f_; }

  Problem() : f_(NULL) {}
  ~Problem() {
    delete[] f_;
  }
  
  void initialize(const int nx, const int ny, const int nz);
  FLOAT accuracy(const FLOAT *f, const FLOAT time) const;
  std::string debug_string() const;
};
