#include <stdio.h>
#include <stdlib.h>
#include <cuda.h>
#include <cuda_runtime.h>

#define N (32)

__global__ void inc(int *array, int len)
{
    int i;
    for (i = 0; i < len; i++)
        array[i]++;
    return;
}

int main(int argc, char *argv[])
{
    int i;
    int arrayH[N];
    int *arrayD;
    size_t array_size;
    for (i=0; i<N; i++)
        arrayH[i] = i;
    printf("input: ");
    for (i=0; i<N; i++)
        printf("%d ", arrayH[i]);
    printf("\n");

    array_size = sizeof(int) * N;
    if (cudaSuccess != cudaMalloc((void **)&arrayD, array_size)) {
        fprintf(stderr, "cudaMalloc failed\n");
        exit(1);
    }
    if (cudaSuccess != cudaMemcpy(arrayD, arrayH, array_size,
                                  cudaMemcpyHostToDevice)) {
        fprintf(stderr, "cudaMemcpy failed\n");
        exit(1);
    }
    
    inc<<<1, 1>>>(arrayD, N);
    if (cudaSuccess != cudaMemcpy(arrayH, arrayD, array_size,
                                  cudaMemcpyDeviceToHost)) {
        fprintf(stderr, "cudaMemcpy failed\n");
        exit(1);
    }
    
    printf("output: ");
    for (i=0; i<N; i++)
        printf("%d ", arrayH[i]);
    printf("\n");
    return 0;
}

